]> git.phdru.name Git - dotfiles.git/blob - .shellrc
Feat(recode-filenames-recursive): Allow to omit parameters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 PS1="$OPS1$SHLVL "
19
20 if test -n "$BASH_VERSION"; then
21    # append to the history file, don't overwrite it
22    shopt -s histappend
23
24    # check the window size after each command and, if necessary,
25    # update the values of LINES and COLUMNS.
26    shopt -s checkwinsize
27
28    # If set, the pattern "**" used in a pathname expansion context will
29    # match all files and zero or more directories and subdirectories.
30    #shopt -s globstar
31 fi
32
33
34 #if [ -x /usr/bin/dircolors ]; then
35 #   # I don't like these aliases - they work only in command line
36 #   # but not in scripts I run from command line.
37 #   # Color parameters must be passed via environment.
38 #   # So instead I put them in shell scripts in ~/bin.
39 #   alias ls='ls --color=auto'
40 #   alias dir='dir --color=auto'
41 #   alias vdir='vdir --color=auto'
42 #
43 #   alias grep='grep --color=auto'
44 #   alias fgrep='fgrep --color=auto'
45 #   alias egrep='egrep --color=auto'
46 #
47 #   alias dmesg='dmesg --human'
48 #fi
49
50
51 case "$HOME" in
52    /home/*)
53       if [ -L /home ]; then
54          START_DIR="`pwd`" &&
55          cd "$HOME" &&
56          HOME="`pwd`" &&
57          cd "$START_DIR"
58       fi
59    ;;
60 esac
61
62
63 if test -n "$BASH_VERSION"; then
64    [ "`type -t ls`" = alias ] && unalias ls
65    [ "`type -t ll`" = alias ] && unalias ll
66    [ "`type -t mc`" = alias ] && unalias mc
67
68    back() { cd - "$@"; }
69    functions() { typeset -f "$@"; }
70    j() { jobs; }
71
72    has_completion() { return 0; }
73    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
74       if [ "$SHELL" = /bin/bash ]; then
75          if [ -d /usr/share/bash-completion -a -f /usr/share/bash-completion/bash_completion ]; then
76             . /usr/share/bash-completion/bash_completion
77             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
78          elif [ -f /etc/bash_completion ]; then
79             . /etc/bash_completion
80             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
81          elif [ -d /etc/bash_completion.d ]; then
82             for _compf in /etc/bash_completion.d/*; do
83                . $_compf
84             done
85             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
86          fi
87       elif [ "$SHELL" = /usr/local/bin/bash ]; then
88          if [ -d /usr/local/etc/bash_completion.d ]; then
89             for _compf in /usr/local/etc/bash_completion.d/*; do
90                . $_compf
91             done
92             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
93          fi
94       else
95          echo "Unknown OS type, cannot source bash_completion" >&2
96       fi
97    fi
98
99    for cmd in builtin cgmem_nice command dbus-launch exec \
100       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
101       time whence whereis which xargs; do
102          ! has_completion $cmd && complete -o default -A command $cmd
103    done
104
105    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
106       telnet t tt \
107       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
108       whois wd wget wget-download wget-m wget-wrapper ww; do
109          ! has_completion $cmd && complete -A hostname $cmd
110    done
111
112    for cmd in distribute ftp lftp r rsync \
113       s scp ssh smbclient tcpdump tshark wireshark; do
114          ! has_completion $cmd && complete -o default -A hostname $cmd
115    done
116
117    if [ -d "$HOME"/.bash_completion.d ]; then
118       for _compf in "$HOME"/.bash_completion.d/*; do
119          . $_compf
120       done
121    fi
122
123    delegate_completion() {
124       local prog programs
125       prog=$1
126       if has_completion $prog; then
127          shift
128          programs="$@"
129          eval "_${prog}_completion_loader() {
130             _completion_loader $prog
131             complete -o nospace -F _$prog $programs
132             unset _${prog}_completion_loader
133             return 124
134          }"
135          complete -F _${prog}_completion_loader $programs
136       fi
137    }
138
139    delegate_completion make m
140    delegate_completion ping p
141    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
142    delegate_completion ssh s
143    delegate_completion wget wget-m wget-wrapper ww
144
145    unset has_completion delegate_completion
146
147    complete -A job bg fg j jobs wait
148    complete -A variable -A function unset
149
150    if [ -d "$HOME/lib/config" ]; then
151       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
152    fi
153    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
154
155    #if type -p pip >/dev/null 2>&1; then
156    #   eval "`pip completion --bash`"
157    #   rm -rf /tmp/pip_build_"$USER"
158    #fi
159
160    #if which pyenv >/dev/null 2>&1; then
161    #   eval "`pyenv init -`"
162    #   eval "`pyenv virtualenv-init -`"
163    #fi
164
165    . virtualenvwrapper_lazy.sh 2>/dev/null
166
167    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
168       . "$VIRTUAL_ENV/bin/activate"
169    fi
170
171    # Clean up python virtual environment on exit
172    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
173
174    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
175
176 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
177    back() { cd - "$@"; }
178    j() { jobs; }
179 fi
180
181
182 # clear screen and history, logout
183 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
184
185
186 if test -x /usr/bin/git >/dev/null 2>&1; then
187    # chdir to a directory
188    cdgitpath() {
189       if [ $# -ne 1 ]; then
190          echo "Usage: cdgitpath path_key" >&2
191          return 1
192       fi
193
194       path_key="$1"
195       if [ -z "$path_key" ]; then
196          echo "Usage: cdgitpath path_key" >&2
197          return 1
198       fi
199
200       path_url="`git config --get --path $path_key`"
201       if echo "$path_url" | grep -q '^file:/'; then
202          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
203       fi
204       cd "$path_url"
205    }
206
207    # chdir to a remote's directory (if the remote is on the local FS)
208    cdremote() {
209       if [ $# -gt 1 ]; then
210          echo "Usage: cdremote [remote_name]" >&2
211          return 1
212       fi
213
214       if [ -z "$1" ]; then
215          branch="`git rev-parse --abbrev-ref HEAD`"
216          remote="`git config --get branch.$branch.remote`"
217       else
218          remote="$1"
219       fi
220
221       if [ -n "$remote" ] && git config --get remote.$remote.url |
222             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
223          cdgitpath remote.$remote.url
224       else
225
226          if [ -n "$1" ]; then
227             echo "Cannot find directory for remote $1" >&2
228             echo "Usage: cdremote [remote_name]" >&2
229             return 1
230          fi
231
232          if test -n "$BASH_VERSION"; then
233             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
234             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
235                remote=${GIT_REMOTES[0]}
236                unset GIT_REMOTES
237                cdgitpath remote.$remote.url
238             else
239                unset GIT_REMOTES
240                echo "Cannot find directory for any remote" >&2
241                echo "Usage: cdremote [remote_name]" >&2
242                return 1
243             fi
244          else
245             echo "Cannot find directory for remote $1" >&2
246             echo "Usage: cdremote [remote_name]" >&2
247             return 1
248          fi
249       fi
250    }
251
252    if test -n "$BASH_VERSION"; then
253       # completion for aliases in global .gitconfig
254
255       # fixup rbi rbia rbiap rbip - do refs name completion
256       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
257       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
258       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
259       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
260       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
261       #
262       # push-to-all-remotes - do branch name completion
263       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
264
265       _cdgitpath_complete() {
266          local cur="${COMP_WORDS[COMP_CWORD]}"
267          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
268       }
269
270       _git_open() {
271          _cdgitpath_complete
272       }
273
274       complete -F _cdgitpath_complete cdgitpath git-open
275
276       # list remotes with URLs matching a regexp
277       _list_remotes() {
278          if [ $# -ne 1 ]; then
279             echo "Usage: _list_remotes remote_regexp" >&2
280             return 1
281          fi
282          declare -ag GIT_REMOTES=()
283          local remote
284          for remote in `git remote`; do
285             if git config --get remote.$remote.url | grep -q "$1"; then
286                GIT_REMOTES+=($remote)
287             fi
288          done
289       }
290
291       # completion for cdremote and git-open-remote - list remotes with a pattern
292       _list_remotes_completion() {
293          local cur="${COMP_WORDS[COMP_CWORD]}"
294          _list_remotes "$1"
295          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
296          unset GIT_REMOTES
297       }
298
299       # completion for cdremote - list remotes with directories as URLs
300       _cdremote_complete() {
301          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
302          if [ ${#COMPREPLY[*]} -eq 0 ]; then
303             _list_remotes_completion .
304          fi
305       }
306
307       complete -F _cdremote_complete cdremote
308
309       # completion for git-open-remote - list remotes with http(s) URLs
310       _git_open_remote() {
311          _list_remotes_completion '^http\(s\)\?://'
312          if [ ${#COMPREPLY[*]} -eq 0 ]; then
313             _list_remotes_completion .
314          fi
315       }
316
317       complete -F _git_open_remote git-open-remote
318    fi
319 fi
320
321
322 include() {
323    cfg="$1"
324    if [ -f "./$cfg" -a -r "./$cfg" ]; then
325       echo "Reading config file \`$cfg'" 1>&2
326       . "./$cfg"
327    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
328       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
329       . "$HOME/lib/config/$cfg"
330    else
331       echo "Cannot find config file \`$cfg'" 1>&2
332    fi
333 }
334
335
336 mc() {
337    if test -n "$BASH_VERSION"; then
338       MC_SAVE_OPS1="$OPS1"
339       OPS1="\u@\h \W \\$"
340    fi
341
342    if [ -n "$SLOWTERM" ]; then
343       MC_SLOW="--slow"
344    fi
345
346    case "$TERM" in
347       screen*) # screen, screen.rxvt
348          MC_XTERM="-x"
349       ;;
350    esac
351
352    #TMPDIR="$HOME"/tmp
353    #export TMPDIR
354
355    MC_FOUND=NO
356
357    for wrapper in \
358          /usr/local/share/mc/bin/mc-wrapper.sh \
359          /usr/local/libexec/mc/mc-wrapper.sh \
360          /usr/share/mc/bin/mc-wrapper.sh; do
361       if [ -r $wrapper ]; then
362          . $wrapper $MC_SLOW $MC_XTERM "$@"
363          rc=$?
364          MC_FOUND=YES
365          break
366       fi
367    done
368
369    if [ $MC_FOUND = NO ]; then
370       for mc in /usr/local/bin/mc /usr/bin/mc; do
371          if [ -x $mc ]; then
372             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
373             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
374                MC_TMP_DIR="${TMPDIR-/tmp}"
375             fi
376             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
377             mc_type="`mc_type.py $mc`"
378             if [ "$mc_type" = old ]; then
379                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
380             elif [ "$mc_type" = new ]; then
381                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
382             else
383                continue
384             fi
385             rc=$?
386             MC_FOUND=YES
387             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
388             break
389          fi
390       done
391    fi
392
393    if [ $MC_FOUND = NO ]; then
394       echo "Cannot find mc-wrapper.sh or mc" >&2
395       rc=1
396    fi
397
398    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
399    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
400
401    return $rc
402 }
403
404
405 mkcd() {
406    if [ $# -ne 1 ]; then
407       echo "Usage: mkcd directory_name" >&2
408    elif [ -d "$1" ]; then
409       cd "$1"
410    elif [ -e "$1" ]; then
411       echo "Error: $1 is a file" >&2
412    else
413       mkdir -p "$1" && cd "$1"
414    fi
415 }
416
417
418 if which tmux >/dev/null 2>&1; then
419    tmux() {
420       case "$TERM" in
421          rxvt)
422             TERM=rxvt-unicode command tmux "$@"
423          ;;
424
425          *)
426             command tmux "$@"
427          ;;
428       esac
429    }
430 fi
431
432
433 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
434    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
435 fi
436
437 x() { exit; }